# -*- coding: utf-8 -*-
"""
Created on Fri Dec 18 11:57:33 2020

@author: Studente
Write a recursive function (or that makes use of your recursive function) that gets as input a pathname of a directory and returns a set with the full pathnames of the subdirectories with the largest amount of bytes used (bytes used by the all the files in that directory). 

"""

import os

def my_aux_function(pathname):
    max_size = 0
    dir_name_set = {pathname}
    my_size = 0
    for filename in os.listdir(pathname):
        fullname = os.path.join(pathname, filename)
        if os.path.isfile(fullname):
            my_size += os.stat(fullname).st_size
        if os.path.isdir(fullname):
            dir_names, dir_size = my_aux_function(fullname)
            if dir_size > max_size:
                max_size = dir_size
                dir_name_set = dir_names
            elif dir_size == max_size:
                dir_name_set.update(dir_names)
    if max_size < my_size:
        dir_name_set = {pathname}
        max_size = my_size
    elif max_size == my_size:
        dir_name_set.add(pathname)
    return dir_name_set, max_size
            


def largest_bytes_dir(pathname):
    return my_aux_function(pathname)[0]
    

