# -*- coding: utf-8 -*-
"""
Created on Fri Dec 18 12:25:06 2020

@author: Studente
Write a recursive function that builds a dictionary with the degree frequences (namely, the degree of a node is the number of subbranches rooted in that node): keys are the degrees and values are the number of nodes with that degree.
"""
import treenode

def build_dict_freq(tree, freq={}):
    for branch in tree.branches:
        build_dict_freq(branch, freq)
    if len(tree.branches) not in freq:
        freq[len(tree.branches)] = 1
    else:
        freq[len(tree.branches)] += 1
    return freq
    
def build_dict_freq_2(tree):
    if tree.branches == []:
        return {0:1}
    my_freq_dic = {len(tree.branches):1}
    for branch in tree.branches:
        freq = build_dict_freq_2(branch)
        for degree in freq:
            my_freq_dic[degree] = my_freq_dic.get(degree, 0) + freq[degree]
    return my_freq_dic